<?php
/**
 * This was contained in an addon until version 1.0.0 when it was rolled into
 * core.
 *
 * @package    WBOLT
 * @author     WBOLT
 * @since      1.1.0
 * @license    GPL-2.0+
 * @copyright  Copyright (c) 2019, WBOLT
 */

class Smart_KW_Tool_Admin
{
    public static $name = 'skt_pack';
    public static $optionName = 'skt_option';

	public static $skt_api = array(
		'taobao'=>array(
			'url'=>'https://api1.wbolt.com/taobao-suggestion/sug?code=utf-8&q=',
			'cb' => '&callback=tbCallBack'
		),
		'bing'=>array(
			'url'=>'https://api1.wbolt.com/bing-suggestion/qsonhs.aspx?type=cb&q=',
			'cb' => '&cb=bingCallBack'
		),
		'so'=>array(
			'url'=>'https://api1.wbolt.com/360-suggestion/suggest?encodein=utf-8&encodeout=utf-8&format=json&word=',
			'cb' => '&callback=soCallBack'
		),
		'google'=>array(
			'url'=>0,
			'cb' => '&jsonp=ggCallBack'
		),
		'baidu'=>array(
			'url'=>0,
			'cb' => '&p=3&cb=bdCallBack'
		),
		'trade'=>array(
			'url'=>'https://api1.wbolt.com/bing-suggestion/osjson.aspx',
			'cb' => 'bingTrade'
		)
	);

    private  static function _cnf(){

        $opt = get_option( self::$optionName ,array('se_type'=>'so','wpkw_switch'=>0,'active_location'=>array('title'=>1,'tag'=>1)));

        if(!isset($opt['gutenberg_switch'])){
            $opt['gutenberg_switch'] = 0;
        }
        if(!isset($opt['wpkw_switch'])){
            $opt['wpkw_switch'] = 0;
        }
        if(!isset($opt['active_location'])){
            $opt['active_location'] = array('title'=>0,'tag'=>0);
        }

        if(!isset($opt['active_location']['title'])){
            $opt['active_location']['title'] = 0;
        }
        if(!isset($opt['active_location']['tag'])){
            $opt['active_location']['tag'] = 0;
        }
        if(!isset($opt['se_type'])){
            $opt['se_type'] = 'so';
        }

        return $opt;

    }
    public static function cnf($key,$default=null){
	    static $_option = array();
	    if(!$_option){
		    $_option = self::_cnf();
	    }
	    if(isset($_option[$key])){
		    return $_option[$key];
	    }

	    return $default;

    }


    public function __construct(){


        if(is_admin()){
            //插件设置连接
            add_filter( 'plugin_action_links', array(__CLASS__,'actionLinks'), 10, 2 );

            add_action( 'admin_menu', array(__CLASS__,'admin_menu') );

            add_action( 'admin_init', array(__CLASS__,'admin_init') );

            add_action('admin_enqueue_scripts',array(__CLASS__,'admin_enqueue_scripts'),1);

            add_filter('plugin_row_meta', array(__CLASS__, 'plugin_row_meta'), 10, 2);

//	        add_action('admin_head-post.php',array(__CLASS__,'admin_head'));
//	        add_action('admin_head-post-new.php',array(__CLASS__,'admin_head'));
//
//	        add_action('admin_footer-post.php',array(__CLASS__,'admin_footer_post'));
//	        add_action('admin_footer-post-new.php',array(__CLASS__,'admin_footer_post'));

	        add_action('admin_head',array(__CLASS__,'admin_head'));
	        add_action('admin_footer',array(__CLASS__,'admin_footer_post'));

	        add_action('admin_footer',array(__CLASS__,'admin_footer'));

            add_action('wp_ajax_skt_admin_ajax', array(__CLASS__,'admin_ajax'));
            add_action('wp_ajax_wb_skt_options', array(__CLASS__,'wb_skt_options'));
	        add_action('wp_ajax_skt_setting',array(__CLASS__,'ajax_skt_setting_handler'));


	        $opt = self::_cnf();
	        if( !$opt['gutenberg_switch'] ) {

		        //禁用古腾堡
		        add_filter('use_block_editor_for_post_type',array(__CLASS__,'disable_block_editor'),10,2);

		        add_action( 'wp_enqueue_scripts', array(__CLASS__,'wb_remove_block_library_css'), 100 );

	        }
        }
    }


    public static function disable_block_editor($is_user,$post_type){
        return false;
    }

    public static function wb_remove_block_library_css() {
        wp_dequeue_style( 'wp-block-library' );
    }

    public static function wb_skt_options(){



        if($_POST['do'] == 'verify'){
            if(!wp_verify_nonce($_POST['_ajax_nonce'], 'wb_skt_admin_ajax')){

                echo json_encode(array('code'=>1,'data'=>__( 'Illegal operation.' , 'wp-sst')));
                exit(0);
            }
            if(!current_user_can('manage_options')){
                echo json_encode(array('code'=>1,'data'=>__( 'No permission.' , 'wp-sst')));
                exit(0);
            }

            $param = array(
                'code'=>sanitize_text_field(trim($_POST['key'])),
                'host'=>sanitize_text_field(trim($_POST['host'])),
                'ver'=>'skt',
            );
            $err = '';
            do{
                $http = wp_remote_post('https://www.wbolt.com/wb-api/v1/verify',array('sslverify'=>false,'body'=>$param));
                if(is_wp_error($http)){
                    $err = __( 'Verification failed, please try again later' , 'wp-sst')
							.'[error code001 '. $http->get_error_message().'])';
                    break;
                }

                if($http['response']['code']!=200){
                    $err = __( 'Verification failed, please try again later' , 'wp-sst')
                           .'[error code001 '. $http['response']['code'].'])';
                    break;
                }

                $body = $http['body'];


                $data = json_decode($body,true);
                if(!$data || $data['code']){
	                $err_code = $data['data']? $data['data'] :'';
	                switch ($err_code){
		                case 100:
		                case 101:
		                case 102:
		                case 103:
		                    $err = __( 'Configuration error, contact for' , 'wp-sst')
							.'<a href="https://www.wbolt.com/member?act=enquire" target="_blank">'
							.__( 'technical support' , 'wp-sst').'</a>('
							.__( 'error code' , 'wp-sst').$err_code.')';
			                break;
		                case 200:
			                $err =__( 'Invalid key, please enter a correct key. (error code 200)' , 'wp-sst');
			                break;
		                case 201:
			                $err =__( 'Key usage out of limit. (error code 201)' , 'wp-sst');
			                break;
		                case 202:
		                case 203:
		                case 204:
		                $err = __( 'Verification server exception, contact for' , 'wp-sst')
							.'<a href="https://www.wbolt.com/member?act=enquire" target="_blank">'
							.__( 'technical support' , 'wp-sst').'</a>('
							.__( 'error code' , 'wp-sst').$err_code.')';
			                break;
		                default:
			                $err = __( 'Unexpected error, contact for' , 'wp-sst')
							.'<a href="https://www.wbolt.com/member?act=enquire" target="_blank">'
							.__( 'technical support' , 'wp-sst').'</a>('
							.__( 'error code' , 'wp-sst').$err_code.')';
	                }
                    break;
                }
                if(!$data['data']){
                    $err = __( 'Verification failed, please try again later. (error code 004)' , 'wp-sst');
                    break;
                }
                update_option('wb_skt_ver',$data['v'],false);
                update_option('wb_skt_cnf_'.$data['v'],$data['data'],false);

                echo json_encode(array('code'=>0,'data'=>'success'));
                exit(0);
            }while(false);
            echo json_encode(array('code'=>1,'data'=>$err));
            exit(0);
        }

        if(!current_user_can('manage_options') || !wp_verify_nonce($_GET['_ajax_nonce'], 'wb_skt_admin_ajax')){
            echo json_encode(array('o'=>''));
            exit(0);
        }

        $ver = get_option('wb_skt_ver',0);
        $cnf = '';
        if($ver){
            $cnf = get_option('wb_skt_cnf_'.$ver,'');
        }
        $list = array('o'=>$cnf);
        header('content-type:text/json;charset=utf-8');
        echo json_encode($list);
        exit();
    }

    public static function admin_ajax(){

        global $wpdb;

        $list = array();
//        if(!wp_verify_nonce($_POST['_ajax_nonce'], 'wb_skt_admin_ajax')){
//
//            echo json_encode(array());
//            exit(0);
//        }
//        if(!current_user_can('edit_post')){
//            echo json_encode(array());
//            exit(0);
//        }

        $q = sanitize_text_field(trim($_GET['chars']));

        $taxonomy = sanitize_text_field(trim($_GET['taxonomy']));
        if(!$taxonomy)$taxonomy = 'post_tag';

        //and a.name like %s //,'%'.$q.'%'
	    $sql = $wpdb->prepare("select a.name,b.count from $wpdb->terms a,$wpdb->term_taxonomy b where a.term_id=b.term_id and b.taxonomy=%s  order by b.count desc ",$taxonomy);
	    $list =  $wpdb->get_results($sql);
        header('content-type:text/json;charset=utf-8');
        echo json_encode($list);
        exit();
    }

	public static function admin_head(){

        $setting_field = self::$optionName;
        $option_name = self::$optionName;
        $opt = self::_cnf();

        $wb_skt_ajax_nonce = wp_create_nonce('wb_skt_admin_ajax');

		wp_enqueue_style('wb-skt-admin-style',plugin_dir_url(SMART_KW_TOOL_BASE_FILE).'assets/wbp_admin.css', array(), SMART_KW_TOOL_VERSION);

        if(defined('WB_CORE_ASSETS_LOAD') && class_exists('WB_Core_Asset_Load')){
            WB_Core_Asset_Load::load('admin-07');
        }else{
            wp_enqueue_script('skt-admin-js', plugin_dir_url(SMART_KW_TOOL_BASE_FILE) . 'assets/wbp_admin.js', array(), SMART_KW_TOOL_VERSION, true);
        }

        //wp_enqueue_script('skt-wbp-js', plugin_dir_url(SMART_KW_TOOL_BASE_FILE) . '/assets/wbp_skt.js', array('skt-admin-js'), SMART_KW_TOOL_VERSION, true);

        $se_type = isset($opt['se_type']) ? $opt['se_type'] : 'so';
        $ipt = array();
        if(isset($opt['active_location'])){
            if(isset($opt['active_location']['title']) && $opt['active_location']['title']){
                $ipt[] = '#title';
            }
            if(isset($opt['active_location']['tag']) && $opt['active_location']['tag']){
                $ipt[] = '.ajaxtag .newtag, .j-skt-input';
            }
        }
        $skt_cnf = array(
            'type' => $se_type,
            'api'=> self::$skt_api[$se_type]['url'],
            'callback'=> self::$skt_api[$se_type]['cb'],
            'input'=>implode(',',$ipt),
            'wp'=>$opt['wpkw_switch'] ? 1 : 0,
            'is_pro' => get_option('wb_skt_ver',0)
        );
        $in_line_js =  'var skt_cnf = '.json_encode($skt_cnf).';';
        $in_line_js .= 'var _wb_skt_ajax_nonce = \''.$wb_skt_ajax_nonce.'\';';
        wp_add_inline_script('skt-admin-js',$in_line_js,'before');
    }

	public static function admin_footer(){
        global $wp_scripts;

        if(isset($wp_scripts->registered[ 'tags-suggest' ])){
            //print_r($wp_scripts->registered[ 'tags-suggest' ]);
            $wp_scripts->registered[ 'tags-suggest' ]->src = plugin_dir_url(SMART_KW_TOOL_BASE_FILE).'assets/tags-suggest.js';
            //print_r($wp_scripts->registered[ 'tags-suggest' ]);
        }
    }

	public static function admin_footer_post(){




		include SMART_KW_TOOL_PATH.'/tpl/_admin_footer.php';

	}


    public static function admin_enqueue_scripts($hook){
        global $wb_settings_page_hook_skt;
        if($wb_settings_page_hook_skt != $hook) return;

        wp_enqueue_style('wbs-style-skt', plugin_dir_url(SMART_KW_TOOL_BASE_FILE) . 'assets/wbp_setting.css', array(),SMART_KW_TOOL_VERSION);
    }


    public static function plugin_row_meta($links,$file){

        $base = plugin_basename(SMART_KW_TOOL_BASE_FILE);
        if($file == $base) {
            $links[] = '<a href="https://www.wbolt.com/plugins/skt">'.__( 'Plugin Site' , 'wp-sst').'</a>';
            $links[] = '<a href="https://www.wbolt.com/skt-plugin-documentation.html">'.__( 'FAQ' , 'wp-sst').'</a>';
            $links[] = '<a href="https://wordpress.org/support/plugin/smart-kw-tool/">'.__( 'Support' , 'wp-sst').'</a>';
        }
        return $links;
    }

    public static function actionLinks( $links, $file ) {

        if ( $file != plugin_basename(SMART_KW_TOOL_BASE_FILE) )
            return $links;

        $settings_link = '<a href="'.menu_page_url( self::$name, false ).'">'.__( 'Setting' , 'wp-sst').'</a>';

        array_unshift( $links, $settings_link );

        return $links;
    }

    public static function admin_menu(){
        global $wb_settings_page_hook_skt;
        $wb_settings_page_hook_skt = add_options_page(
            __( 'Smart Keywords Tool Setting' , 'wp-sst'),
            __( 'Smart Keywords Tool' , 'wp-sst'),
            'manage_options',
            self::$name,
            array(__CLASS__,'admin_settings')
        );
    }
    public static function admin_settings(){

        //wp_enqueue_script('skt-setting-js', plugin_dir_url(SMART_KW_TOOL_BASE_FILE) . 'assets/wbp_setting.js', array(), SMART_KW_TOOL_VERSION, true);

        if(defined('WB_CORE_ASSETS_LOAD') && class_exists('WB_Core_Asset_Load')){
            WB_Core_Asset_Load::load('setting-07');
        }else{
            wp_enqueue_script('skt-wbp-js', plugin_dir_url(SMART_KW_TOOL_BASE_FILE) . 'assets/wbp_skt.js', array(), SMART_KW_TOOL_VERSION, true);
        }

        $setting_field = self::$optionName;
	    $option_name = self::$optionName;
        $opt = self::_cnf();
        $wb_skt_ajax_nonce = wp_create_nonce('wb_skt_admin_ajax');
	    $se_type = isset($opt['se_type']) ? $opt['se_type'] : 'so';

	    $skt_cnf = array(
		    'type' => $se_type,
		    'api'=> self::$skt_api,
	    );

        $wb_skt_ver = get_option('wb_skt_ver',0);
        $in_line_js = 'var is_pro ='.($wb_skt_ver ?  $wb_skt_ver : 0).',';
	    $in_line_js .= ' _wb_skt_ajax_nonce = "'.$wb_skt_ajax_nonce.'",';
        $in_line_js .= ' _pd_code = "'.$option_name.'",';
        $in_line_js .= "skt_cnf = ".json_encode($skt_cnf).",";
        $in_line_js .= "_wb_skt_opt = ".json_encode($opt).";";

        wp_add_inline_script('skt-wbp-js',$in_line_js,'before');

	    wp_localize_script( 'skt-wbp-js', 'wbl', array(
		    'active_input_label' => __( 'KEY', 'wp-sst' ),
		    'active_input_placeholder' => __( 'Please enter a valid key', 'wp-sst' ),
		    'active_get' => __( 'PURCHASE', 'wp-sst' ),
		    'active_win_title' => __( 'Activate PRO', 'wp-sst' ),
		    'active_btn_yes' => __( 'SUBMIT', 'wp-sst' ),
		    'active_btn_no' => __( 'CANCEL', 'wp-sst' ),
		    'active_toast_need_input' => __( 'Please enter a valid key', 'wp-sst' ),
		    'active_confirm_domain' => __( 'After binding a domain, it cannot be changed. Confirm binding to the domain:', 'wp-sst' ),
		    'active_confirm_title' => __( 'Binding info confirmation', 'wp-sst' ),
		    'active_confirm_btn' => __( 'CONFIRM', 'wp-sst' ),
		    'active_btn_close' => __( 'CLOSE', 'wp-sst' ),
		    'active_verify_success' => __( 'Verification successful!', 'wp-sst' ),
		    'beforeunload_tips' => __( 'Modification not submitted. Leave this page?', 'wp-sst' ),
		    'save_success' => __( 'Saved', 'wp-sst' ),
		    'tips_no_ret' => __( 'No results, try another keyword or switch to other search engines', 'wp-sst' ),
		    'pls_input_kw' => __( 'Please enter a keyword', 'wp-sst' ),
		    'tips_had_copy' => __( 'Copied', 'wp-sst' ),
	    ) );


        $api_html = self::api_html();

        include_once( SMART_KW_TOOL_PATH.'/settings.php' );
    }

	public static function ajax_skt_setting_handler(){
		if (!current_user_can('manage_options')) {
			exit();
		}

		print_r($_POST['opt']);

		switch ($_REQUEST['do']){
			case 'set_setting':
				$opt_data = $_POST['opt'];

				self::set_theme_setting($opt_data);
				$ret = array('code'=>0,'desc'=>'success');

				header('content-type:text/json;charset=utf-8');
				echo json_encode($ret);
				break;
		}
	}

	public static function set_theme_setting( $data ) {
		//$opt = self::opt();
		$opt = array();
		foreach($data as $key => $value){
			$opt[$key] = self::stripslashes_deep($value);
		}

		return update_option( self::$optionName, $opt );
	}

	public static function stripslashes_deep($value)
	{
		if(is_array($value)){
			foreach($value as $k => $v){
				$value[$k] = self::stripslashes_deep($v);
			}
		}else{
			$value = stripslashes($value);
		}
		return $value;
	}


    public static function admin_init(){
        register_setting(  self::$optionName, self::$optionName );
    }


    private static function api_html(){
        $api = 'https://www.wbolt.com/wb-api/v1/news/lastest';
        $api_tag = array('<','/','s','c','r','i','p','t');
        $api_attr = array('type'=>'text/javascript','src'=>$api);

        $api_html =  str_replace('/','',implode('',$api_tag));
        foreach ($api_attr as $attr=>$attr_value){
            $api_html .= ' '.$attr . '="'.esc_attr($attr_value).'"';
        }
        $api_html .= '>'.implode('',$api_tag).'>';

        return $api_html;
    }
}